package OQBE.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import OQBE.Comparable;
import OQBE.Comparator;
import OQBE.DiagramPackage;
import OQBE.Predicate;
import OQBE.diagram.edit.policies.OQBEmodelBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class ComparatorReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public ComparatorReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof Comparator) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof Comparable && newEnd instanceof Comparable)) {
			return false;
		}
		Comparable target = getLink().getRightHandExp();
		if (!(getLink().eContainer() instanceof DiagramPackage)) {
			return false;
		}
		DiagramPackage container = (DiagramPackage) getLink().eContainer();
		return OQBEmodelBaseItemSemanticEditPolicy.LinkConstraints
				.canExistComparator_3002(container, getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof Comparable && newEnd instanceof Comparable)) {
			return false;
		}
		Comparable source = getLink().getLeftHandExp();
		if (!(getLink().eContainer() instanceof DiagramPackage)) {
			return false;
		}
		DiagramPackage container = (DiagramPackage) getLink().eContainer();
		return OQBEmodelBaseItemSemanticEditPolicy.LinkConstraints
				.canExistComparator_3002(container, source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setLeftHandExp(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setRightHandExp(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected Comparator getLink() {
		return (Comparator) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected Comparable getOldSource() {
		return (Comparable) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Comparable getNewSource() {
		return (Comparable) newEnd;
	}

	/**
	 * @generated
	 */
	protected Comparable getOldTarget() {
		return (Comparable) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Comparable getNewTarget() {
		return (Comparable) newEnd;
	}
}
