package OQBE.diagram.edit.commands;

import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.common.core.command.CommandResult;
import org.eclipse.gmf.runtime.emf.type.core.commands.EditElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import OQBE.DiagramPackage;
import OQBE.Example;
import OQBE.LinkExample;
import OQBE.diagram.edit.policies.OQBEmodelBaseItemSemanticEditPolicy;

/**
 * @generated
 */
public class LinkExampleReorientCommand extends EditElementCommand {

	/**
	 * @generated
	 */
	private final int reorientDirection;

	/**
	 * @generated
	 */
	private final EObject oldEnd;

	/**
	 * @generated
	 */
	private final EObject newEnd;

	/**
	 * @generated
	 */
	public LinkExampleReorientCommand(ReorientRelationshipRequest request) {
		super(request.getLabel(), request.getRelationship(), request);
		reorientDirection = request.getDirection();
		oldEnd = request.getOldRelationshipEnd();
		newEnd = request.getNewRelationshipEnd();
	}

	/**
	 * @generated
	 */
	public boolean canExecute() {
		if (false == getElementToEdit() instanceof LinkExample) {
			return false;
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return canReorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return canReorientTarget();
		}
		return false;
	}

	/**
	 * @generated
	 */
	protected boolean canReorientSource() {
		if (!(oldEnd instanceof Example && newEnd instanceof Example)) {
			return false;
		}
		Example target = getLink().getTarget();
		if (!(getLink().eContainer() instanceof DiagramPackage)) {
			return false;
		}
		DiagramPackage container = (DiagramPackage) getLink().eContainer();
		return OQBEmodelBaseItemSemanticEditPolicy.LinkConstraints
				.canExistLinkExample_3001(container, getNewSource(), target);
	}

	/**
	 * @generated
	 */
	protected boolean canReorientTarget() {
		if (!(oldEnd instanceof Example && newEnd instanceof Example)) {
			return false;
		}
		Example source = getLink().getSource();
		if (!(getLink().eContainer() instanceof DiagramPackage)) {
			return false;
		}
		DiagramPackage container = (DiagramPackage) getLink().eContainer();
		return OQBEmodelBaseItemSemanticEditPolicy.LinkConstraints
				.canExistLinkExample_3001(container, source, getNewTarget());
	}

	/**
	 * @generated
	 */
	protected CommandResult doExecuteWithResult(IProgressMonitor monitor,
			IAdaptable info) throws ExecutionException {
		if (!canExecute()) {
			throw new ExecutionException(
					"Invalid arguments in reorient link command"); //$NON-NLS-1$
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_SOURCE) {
			return reorientSource();
		}
		if (reorientDirection == ReorientRelationshipRequest.REORIENT_TARGET) {
			return reorientTarget();
		}
		throw new IllegalStateException();
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientSource() throws ExecutionException {
		getLink().setSource(getNewSource());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected CommandResult reorientTarget() throws ExecutionException {
		getLink().setTarget(getNewTarget());
		return CommandResult.newOKCommandResult(getLink());
	}

	/**
	 * @generated
	 */
	protected LinkExample getLink() {
		return (LinkExample) getElementToEdit();
	}

	/**
	 * @generated
	 */
	protected Example getOldSource() {
		return (Example) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Example getNewSource() {
		return (Example) newEnd;
	}

	/**
	 * @generated
	 */
	protected Example getOldTarget() {
		return (Example) oldEnd;
	}

	/**
	 * @generated
	 */
	protected Example getNewTarget() {
		return (Example) newEnd;
	}
}
