package OQBE.diagram.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrappingLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

import OQBE.diagram.part.OQBEmodelVisualIDRegistry;

/**
 * @generated
 */
public class OQBEmodelEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {

			case DiagramPackageEditPart.VISUAL_ID:
				return new DiagramPackageEditPart(view);

			case ExampleEditPart.VISUAL_ID:
				return new ExampleEditPart(view);

			case ExampleExampleNameClassNameEditPart.VISUAL_ID:
				return new ExampleExampleNameClassNameEditPart(view);

			case NestedOutputEditPart.VISUAL_ID:
				return new NestedOutputEditPart(view);

			case NestedOutputTupleFieldNameEditPart.VISUAL_ID:
				return new NestedOutputTupleFieldNameEditPart(view);

			case ForAllEditPart.VISUAL_ID:
				return new ForAllEditPart(view);

			case WrappingLabelEditPart.VISUAL_ID:
				return new WrappingLabelEditPart(view);

			case PredicateEditPart.VISUAL_ID:
				return new PredicateEditPart(view);

			case PredicatePredicateNameOperatorArEditPart.VISUAL_ID:
				return new PredicatePredicateNameOperatorArEditPart(view);

			case OutputFlagEditPart.VISUAL_ID:
				return new OutputFlagEditPart(view);

			case OutputFlagTupleFieldNameEditPart.VISUAL_ID:
				return new OutputFlagTupleFieldNameEditPart(view);

			case SortFlagEditPart.VISUAL_ID:
				return new SortFlagEditPart(view);

			case SortFlagOrderPriorityEditPart.VISUAL_ID:
				return new SortFlagOrderPriorityEditPart(view);

			case OutputFlag2EditPart.VISUAL_ID:
				return new OutputFlag2EditPart(view);

			case OutputFlagTupleFieldName2EditPart.VISUAL_ID:
				return new OutputFlagTupleFieldName2EditPart(view);

			case OclExpressionEditPart.VISUAL_ID:
				return new OclExpressionEditPart(view);

			case OclExpressionExpressionEditPart.VISUAL_ID:
				return new OclExpressionExpressionEditPart(view);

			case OutputFlag3EditPart.VISUAL_ID:
				return new OutputFlag3EditPart(view);

			case OutputFlagTupleFieldName3EditPart.VISUAL_ID:
				return new OutputFlagTupleFieldName3EditPart(view);

			case SortFlag2EditPart.VISUAL_ID:
				return new SortFlag2EditPart(view);

			case SortFlagOrderPriority2EditPart.VISUAL_ID:
				return new SortFlagOrderPriority2EditPart(view);

			case NestedOutput2EditPart.VISUAL_ID:
				return new NestedOutput2EditPart(view);

			case NestedOutputTupleFieldName2EditPart.VISUAL_ID:
				return new NestedOutputTupleFieldName2EditPart(view);

			case Example2EditPart.VISUAL_ID:
				return new Example2EditPart(view);

			case ExampleExampleNameClassName2EditPart.VISUAL_ID:
				return new ExampleExampleNameClassName2EditPart(view);

			case ForAll2EditPart.VISUAL_ID:
				return new ForAll2EditPart(view);

			case WrappingLabel2EditPart.VISUAL_ID:
				return new WrappingLabel2EditPart(view);

			case Example3EditPart.VISUAL_ID:
				return new Example3EditPart(view);

			case ExampleExampleNameClassName3EditPart.VISUAL_ID:
				return new ExampleExampleNameClassName3EditPart(view);

			case ExamplePredicateCompartmentEditPart.VISUAL_ID:
				return new ExamplePredicateCompartmentEditPart(view);

			case ExamplePredicateCompartment2EditPart.VISUAL_ID:
				return new ExamplePredicateCompartment2EditPart(view);

			case ExamplePredicateCompartment3EditPart.VISUAL_ID:
				return new ExamplePredicateCompartment3EditPart(view);

			case LinkExampleEditPart.VISUAL_ID:
				return new LinkExampleEditPart(view);

			case LinkExampleLinkNameEditPart.VISUAL_ID:
				return new LinkExampleLinkNameEditPart(view);

			case ComparatorEditPart.VISUAL_ID:
				return new ComparatorEditPart(view);

			case ComparatorOperatorEditPart.VISUAL_ID:
				return new ComparatorOperatorEditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrappingLabel)
			return new TextCellEditorLocator((WrappingLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrappingLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrappingLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrappingLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapOn()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
