package OQBE.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import OQBE.OQBEPackage;
import OQBE.diagram.edit.commands.ComparatorCreateCommand;
import OQBE.diagram.edit.commands.ComparatorReorientCommand;
import OQBE.diagram.edit.commands.LinkExampleCreateCommand;
import OQBE.diagram.edit.commands.LinkExampleReorientCommand;
import OQBE.diagram.edit.commands.OutputFlag2CreateCommand;
import OQBE.diagram.edit.commands.OutputFlag3CreateCommand;
import OQBE.diagram.edit.parts.ComparatorEditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment2EditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment3EditPart;
import OQBE.diagram.edit.parts.LinkExampleEditPart;
import OQBE.diagram.edit.parts.NestedOutput2EditPart;
import OQBE.diagram.edit.parts.OclExpressionEditPart;
import OQBE.diagram.edit.parts.OutputFlag2EditPart;
import OQBE.diagram.edit.parts.OutputFlag3EditPart;
import OQBE.diagram.edit.parts.PredicateEditPart;
import OQBE.diagram.part.OQBEmodelVisualIDRegistry;
import OQBE.diagram.providers.OQBEmodelElementTypes;

/**
 * @generated
 */
public class Example3ItemSemanticEditPolicy extends
		OQBEmodelBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (OQBEmodelElementTypes.OutputFlag_2004 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getExample_Output());
			}
			return getGEFWrapper(new OutputFlag2CreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (OQBEmodelVisualIDRegistry.getVisualID(node)) {
			case OutputFlag2EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			case ExamplePredicateCompartment3EditPart.VISUAL_ID:
				for (Iterator cit = node.getChildren().iterator(); cit
						.hasNext();) {
					Node cnode = (Node) cit.next();
					switch (OQBEmodelVisualIDRegistry.getVisualID(cnode)) {
					case PredicateEditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					case OclExpressionEditPart.VISUAL_ID:
						cmd.add(getDestroyElementCommand(cnode));
						break;
					}
				}
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (OQBEmodelElementTypes.LinkExample_3001 == req.getElementType()) {
			return getGEFWrapper(new LinkExampleCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (OQBEmodelElementTypes.Comparator_3002 == req.getElementType()) {
			return getGEFWrapper(new ComparatorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (OQBEmodelElementTypes.LinkExample_3001 == req.getElementType()) {
			return getGEFWrapper(new LinkExampleCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		if (OQBEmodelElementTypes.Comparator_3002 == req.getElementType()) {
			return getGEFWrapper(new ComparatorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case LinkExampleEditPart.VISUAL_ID:
			return getGEFWrapper(new LinkExampleReorientCommand(req));
		case ComparatorEditPart.VISUAL_ID:
			return getGEFWrapper(new ComparatorReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

}
