package OQBE.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import OQBE.OQBEPackage;
import OQBE.diagram.edit.commands.Example2CreateCommand;
import OQBE.diagram.edit.commands.ForAll2CreateCommand;
import OQBE.diagram.edit.commands.NestedOutput2CreateCommand;
import OQBE.diagram.edit.commands.SortFlagCreateCommand;
import OQBE.diagram.edit.parts.Example2EditPart;
import OQBE.diagram.edit.parts.ForAll2EditPart;
import OQBE.diagram.edit.parts.NestedOutput2EditPart;
import OQBE.diagram.edit.parts.SortFlagEditPart;
import OQBE.diagram.part.OQBEmodelVisualIDRegistry;
import OQBE.diagram.providers.OQBEmodelElementTypes;

/**
 * @generated
 */
public class NestedOutput2ItemSemanticEditPolicy extends
		OQBEmodelBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (OQBEmodelElementTypes.NestedOutput_2008 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getNestedOutput_NestedOutputs());
			}
			return getGEFWrapper(new NestedOutput2CreateCommand(req));
		}
		if (OQBEmodelElementTypes.Example_2009 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getNestedOutput_NestedExamples());
			}
			return getGEFWrapper(new Example2CreateCommand(req));
		}
		if (OQBEmodelElementTypes.ForAll_2010 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getNestedOutput_NestedForAlls());
			}
			return getGEFWrapper(new ForAll2CreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (OQBEmodelVisualIDRegistry.getVisualID(node)) {
			case NestedOutput2EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			case Example2EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			case ForAll2EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			}
		}
	}

}
