package OQBE.diagram.edit.policies;

import java.util.Iterator;

import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;

import OQBE.OQBEPackage;
import OQBE.diagram.edit.commands.OutputFlag3CreateCommand;
import OQBE.diagram.edit.commands.SortFlag2CreateCommand;
import OQBE.diagram.edit.parts.OutputFlag3EditPart;
import OQBE.diagram.edit.parts.SortFlag2EditPart;
import OQBE.diagram.part.OQBEmodelVisualIDRegistry;
import OQBE.diagram.providers.OQBEmodelElementTypes;

/**
 * @generated
 */
public class OclExpressionItemSemanticEditPolicy extends
		OQBEmodelBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (OQBEmodelElementTypes.OutputFlag_2006 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getOclExpression_Output());
			}
			return getGEFWrapper(new OutputFlag3CreateCommand(req));
		}
		if (OQBEmodelElementTypes.SortFlag_2007 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getOclExpression_Sort());
			}
			return getGEFWrapper(new SortFlag2CreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (OQBEmodelVisualIDRegistry.getVisualID(node)) {
			case OutputFlag3EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			case SortFlag2EditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			}
		}
	}

}
