package OQBE.diagram.edit.policies;

import java.util.Iterator;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import org.eclipse.gmf.runtime.notation.Node;
import org.eclipse.gmf.runtime.notation.View;
import OQBE.OQBEPackage;
import OQBE.diagram.edit.commands.ComparatorCreateCommand;
import OQBE.diagram.edit.commands.ComparatorReorientCommand;
import OQBE.diagram.edit.commands.OutputFlag2CreateCommand;
import OQBE.diagram.edit.commands.OutputFlagCreateCommand;
import OQBE.diagram.edit.commands.SortFlagCreateCommand;
import OQBE.diagram.edit.parts.ComparatorEditPart;
import OQBE.diagram.edit.parts.OutputFlag2EditPart;
import OQBE.diagram.edit.parts.OutputFlagEditPart;
import OQBE.diagram.edit.parts.SortFlagEditPart;
import OQBE.diagram.part.OQBEmodelVisualIDRegistry;
import OQBE.diagram.providers.OQBEmodelElementTypes;

/**
 * @generated
 */
public class PredicateItemSemanticEditPolicy extends
		OQBEmodelBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	protected Command getCreateCommand(CreateElementRequest req) {
		if (OQBEmodelElementTypes.OutputFlag_2002 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getPredicate_Output());
			}
			return getGEFWrapper(new OutputFlagCreateCommand(req));
		}
		if (OQBEmodelElementTypes.SortFlag_2003 == req.getElementType()) {
			if (req.getContainmentFeature() == null) {
				req.setContainmentFeature(OQBEPackage.eINSTANCE
						.getPredicate_Sort());
			}
			return getGEFWrapper(new SortFlagCreateCommand(req));
		}
		return super.getCreateCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		CompoundCommand cc = getDestroyEdgesCommand();
		addDestroyChildNodesCommand(cc);
		addDestroyShortcutsCommand(cc);
		cc.add(getGEFWrapper(new DestroyElementCommand(req)));
		return cc.unwrap();
	}

	/**
	 * @generated
	 */
	protected void addDestroyChildNodesCommand(CompoundCommand cmd) {
		View view = (View) getHost().getModel();
		EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
		if (annotation != null) {
			return;
		}
		for (Iterator it = view.getChildren().iterator(); it.hasNext();) {
			Node node = (Node) it.next();
			switch (OQBEmodelVisualIDRegistry.getVisualID(node)) {
			case OutputFlagEditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			case SortFlagEditPart.VISUAL_ID:
				cmd.add(getDestroyElementCommand(node));
				break;
			}
		}
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (OQBEmodelElementTypes.Comparator_3002 == req.getElementType()) {
			return getGEFWrapper(new ComparatorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (OQBEmodelElementTypes.Comparator_3002 == req.getElementType()) {
			return getGEFWrapper(new ComparatorCreateCommand(req, req
					.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case ComparatorEditPart.VISUAL_ID:
			return getGEFWrapper(new ComparatorReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

}
