package OQBE.diagram.navigator;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.gmf.runtime.common.ui.services.parser.IParser;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserOptions;
import org.eclipse.gmf.runtime.common.ui.services.parser.ParserService;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.resource.ImageRegistry;
import org.eclipse.jface.viewers.ITreePathLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreePath;
import org.eclipse.jface.viewers.ViewerLabel;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.IMemento;
import org.eclipse.ui.navigator.ICommonContentExtensionSite;
import org.eclipse.ui.navigator.ICommonLabelProvider;

import OQBE.DiagramPackage;
import OQBE.diagram.edit.parts.ComparatorEditPart;
import OQBE.diagram.edit.parts.ComparatorOperatorEditPart;
import OQBE.diagram.edit.parts.DiagramPackageEditPart;
import OQBE.diagram.edit.parts.Example2EditPart;
import OQBE.diagram.edit.parts.Example3EditPart;
import OQBE.diagram.edit.parts.ExampleEditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassName2EditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassName3EditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassNameEditPart;
import OQBE.diagram.edit.parts.ForAll2EditPart;
import OQBE.diagram.edit.parts.ForAllEditPart;
import OQBE.diagram.edit.parts.LinkExampleEditPart;
import OQBE.diagram.edit.parts.LinkExampleLinkNameEditPart;
import OQBE.diagram.edit.parts.NestedOutput2EditPart;
import OQBE.diagram.edit.parts.NestedOutputEditPart;
import OQBE.diagram.edit.parts.NestedOutputTupleFieldName2EditPart;
import OQBE.diagram.edit.parts.NestedOutputTupleFieldNameEditPart;
import OQBE.diagram.edit.parts.OclExpressionEditPart;
import OQBE.diagram.edit.parts.OclExpressionExpressionEditPart;
import OQBE.diagram.edit.parts.OutputFlag2EditPart;
import OQBE.diagram.edit.parts.OutputFlag3EditPart;
import OQBE.diagram.edit.parts.OutputFlagEditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldName2EditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldName3EditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldNameEditPart;
import OQBE.diagram.edit.parts.PredicateEditPart;
import OQBE.diagram.edit.parts.PredicatePredicateNameOperatorArEditPart;
import OQBE.diagram.edit.parts.SortFlag2EditPart;
import OQBE.diagram.edit.parts.SortFlagEditPart;
import OQBE.diagram.edit.parts.SortFlagOrderPriority2EditPart;
import OQBE.diagram.edit.parts.SortFlagOrderPriorityEditPart;
import OQBE.diagram.edit.parts.WrappingLabel2EditPart;
import OQBE.diagram.edit.parts.WrappingLabelEditPart;
import OQBE.diagram.part.OQBEmodelDiagramEditorPlugin;
import OQBE.diagram.part.OQBEmodelVisualIDRegistry;
import OQBE.diagram.providers.OQBEmodelElementTypes;
import OQBE.diagram.providers.OQBEmodelParserProvider;

/**
 * @generated
 */
public class OQBEmodelNavigatorLabelProvider extends LabelProvider implements
		ICommonLabelProvider, ITreePathLabelProvider {

	/**
	 * @generated
	 */
	static {
		OQBEmodelDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?UnknownElement", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
		OQBEmodelDiagramEditorPlugin
				.getInstance()
				.getImageRegistry()
				.put(
						"Navigator?ImageNotFound", ImageDescriptor.getMissingImageDescriptor()); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	public void updateLabel(ViewerLabel label, TreePath elementPath) {
		Object element = elementPath.getLastSegment();
		if (element instanceof OQBEmodelNavigatorItem
				&& !isOwnView(((OQBEmodelNavigatorItem) element).getView())) {
			return;
		}
		label.setText(getText(element));
		label.setImage(getImage(element));
	}

	/**
	 * @generated
	 */
	public Image getImage(Object element) {
		if (element instanceof OQBEmodelNavigatorGroup) {
			OQBEmodelNavigatorGroup group = (OQBEmodelNavigatorGroup) element;
			return OQBEmodelDiagramEditorPlugin.getInstance().getBundledImage(
					group.getIcon());
		}

		if (element instanceof OQBEmodelNavigatorItem) {
			OQBEmodelNavigatorItem navigatorItem = (OQBEmodelNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return super.getImage(element);
			}
			return getImage(navigatorItem.getView());
		}

		return super.getImage(element);
	}

	/**
	 * @generated
	 */
	public Image getImage(View view) {
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case DiagramPackageEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Diagram?editor?DiagramPackage", OQBEmodelElementTypes.DiagramPackage_79); //$NON-NLS-1$
		case ExampleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?editor?Example", OQBEmodelElementTypes.Example_1001); //$NON-NLS-1$
		case NestedOutputEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?editor?NestedOutput", OQBEmodelElementTypes.NestedOutput_1002); //$NON-NLS-1$
		case ForAllEditPart.VISUAL_ID:
			return getImage(
					"Navigator?TopLevelNode?editor?ForAll", OQBEmodelElementTypes.ForAll_1003); //$NON-NLS-1$
		case PredicateEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?Predicate", OQBEmodelElementTypes.Predicate_2001); //$NON-NLS-1$
		case OutputFlagEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?OutputFlag", OQBEmodelElementTypes.OutputFlag_2002); //$NON-NLS-1$
		case SortFlagEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?SortFlag", OQBEmodelElementTypes.SortFlag_2003); //$NON-NLS-1$
		case OutputFlag2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?OutputFlag", OQBEmodelElementTypes.OutputFlag_2004); //$NON-NLS-1$
		case OclExpressionEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?OclExpression", OQBEmodelElementTypes.OclExpression_2005); //$NON-NLS-1$
		case OutputFlag3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?OutputFlag", OQBEmodelElementTypes.OutputFlag_2006); //$NON-NLS-1$
		case SortFlag2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?SortFlag", OQBEmodelElementTypes.SortFlag_2007); //$NON-NLS-1$
		case NestedOutput2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?NestedOutput", OQBEmodelElementTypes.NestedOutput_2008); //$NON-NLS-1$
		case Example2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?Example", OQBEmodelElementTypes.Example_2009); //$NON-NLS-1$
		case ForAll2EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?ForAll", OQBEmodelElementTypes.ForAll_2010); //$NON-NLS-1$
		case Example3EditPart.VISUAL_ID:
			return getImage(
					"Navigator?Node?editor?Example", OQBEmodelElementTypes.Example_2011); //$NON-NLS-1$
		case LinkExampleEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?editor?LinkExample", OQBEmodelElementTypes.LinkExample_3001); //$NON-NLS-1$
		case ComparatorEditPart.VISUAL_ID:
			return getImage(
					"Navigator?Link?editor?Comparator", OQBEmodelElementTypes.Comparator_3002); //$NON-NLS-1$
		}
		return getImage("Navigator?UnknownElement", null); //$NON-NLS-1$
	}

	/**
	 * @generated
	 */
	private Image getImage(String key, IElementType elementType) {
		ImageRegistry imageRegistry = OQBEmodelDiagramEditorPlugin
				.getInstance().getImageRegistry();
		Image image = imageRegistry.get(key);
		if (image == null && elementType != null
				&& OQBEmodelElementTypes.isKnownElementType(elementType)) {
			image = OQBEmodelElementTypes.getImage(elementType);
			imageRegistry.put(key, image);
		}

		if (image == null) {
			image = imageRegistry.get("Navigator?ImageNotFound"); //$NON-NLS-1$
			imageRegistry.put(key, image);
		}
		return image;
	}

	/**
	 * @generated
	 */
	public String getText(Object element) {
		if (element instanceof OQBEmodelNavigatorGroup) {
			OQBEmodelNavigatorGroup group = (OQBEmodelNavigatorGroup) element;
			return group.getGroupName();
		}

		if (element instanceof OQBEmodelNavigatorItem) {
			OQBEmodelNavigatorItem navigatorItem = (OQBEmodelNavigatorItem) element;
			if (!isOwnView(navigatorItem.getView())) {
				return null;
			}
			return getText(navigatorItem.getView());
		}

		return super.getText(element);
	}

	/**
	 * @generated
	 */
	public String getText(View view) {
		if (view.getElement() != null && view.getElement().eIsProxy()) {
			return getUnresolvedDomainElementProxyText(view);
		}
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case DiagramPackageEditPart.VISUAL_ID:
			return getDiagramPackage_79Text(view);
		case ExampleEditPart.VISUAL_ID:
			return getExample_1001Text(view);
		case NestedOutputEditPart.VISUAL_ID:
			return getNestedOutput_1002Text(view);
		case ForAllEditPart.VISUAL_ID:
			return getForAll_1003Text(view);
		case PredicateEditPart.VISUAL_ID:
			return getPredicate_2001Text(view);
		case OutputFlagEditPart.VISUAL_ID:
			return getOutputFlag_2002Text(view);
		case SortFlagEditPart.VISUAL_ID:
			return getSortFlag_2003Text(view);
		case OutputFlag2EditPart.VISUAL_ID:
			return getOutputFlag_2004Text(view);
		case OclExpressionEditPart.VISUAL_ID:
			return getOclExpression_2005Text(view);
		case OutputFlag3EditPart.VISUAL_ID:
			return getOutputFlag_2006Text(view);
		case SortFlag2EditPart.VISUAL_ID:
			return getSortFlag_2007Text(view);
		case NestedOutput2EditPart.VISUAL_ID:
			return getNestedOutput_2008Text(view);
		case Example2EditPart.VISUAL_ID:
			return getExample_2009Text(view);
		case ForAll2EditPart.VISUAL_ID:
			return getForAll_2010Text(view);
		case Example3EditPart.VISUAL_ID:
			return getExample_2011Text(view);
		case LinkExampleEditPart.VISUAL_ID:
			return getLinkExample_3001Text(view);
		case ComparatorEditPart.VISUAL_ID:
			return getComparator_3002Text(view);
		}
		return getUnknownElementText(view);
	}

	/**
	 * @generated
	 */
	private String getDiagramPackage_79Text(View view) {
		DiagramPackage domainModelElement = (DiagramPackage) view.getElement();
		if (domainModelElement != null) {
			return String.valueOf(domainModelElement.getMacroName());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"No domain element for view with visualID = " + 79); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}
	}

	/**
	 * @generated
	 */
	private String getExample_1001Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.Example_1001,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(ExampleExampleNameClassNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4008); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getNestedOutput_1002Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.NestedOutput_1002,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(NestedOutputTupleFieldNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4013); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getForAll_1003Text(View view) {

		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.ForAll_1003,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(WrappingLabelEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);
		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getPredicate_2001Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.Predicate_2001,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(PredicatePredicateNameOperatorArEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4003); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getOutputFlag_2002Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.OutputFlag_2002,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(OutputFlagTupleFieldNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4001); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getSortFlag_2003Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.SortFlag_2003,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(SortFlagOrderPriorityEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4002); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getOutputFlag_2004Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.OutputFlag_2004,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(OutputFlagTupleFieldName2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4004); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getOclExpression_2005Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.OclExpression_2005,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(OclExpressionExpressionEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4007); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getOutputFlag_2006Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.OutputFlag_2006,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(OutputFlagTupleFieldName3EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4005); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getSortFlag_2007Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.SortFlag_2007,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(SortFlagOrderPriority2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4006); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getNestedOutput_2008Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.NestedOutput_2008,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(NestedOutputTupleFieldName2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4012); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getExample_2009Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.Example_2009,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(ExampleExampleNameClassName2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4009); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getForAll_2010Text(View view) {

		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.ForAll_2010,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(WrappingLabel2EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);
		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getExample_2011Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.Example_2011,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(ExampleExampleNameClassName3EditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4010); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getLinkExample_3001Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.LinkExample_3001,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(LinkExampleLinkNameEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4015); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getComparator_3002Text(View view) {
		IAdaptable hintAdapter = new OQBEmodelParserProvider.HintAdapter(
				OQBEmodelElementTypes.Comparator_3002,
				(view.getElement() != null ? view.getElement() : view),
				OQBEmodelVisualIDRegistry
						.getType(ComparatorOperatorEditPart.VISUAL_ID));
		IParser parser = ParserService.getInstance().getParser(hintAdapter);

		if (parser != null) {
			return parser.getPrintString(hintAdapter, ParserOptions.NONE
					.intValue());
		} else {
			OQBEmodelDiagramEditorPlugin.getInstance().logError(
					"Parser was not found for label " + 4016); //$NON-NLS-1$
			return ""; //$NON-NLS-1$
		}

	}

	/**
	 * @generated
	 */
	private String getUnknownElementText(View view) {
		return "<UnknownElement Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	private String getUnresolvedDomainElementProxyText(View view) {
		return "<Unresolved domain element Visual_ID = " + view.getType() + ">"; //$NON-NLS-1$ //$NON-NLS-2$
	}

	/**
	 * @generated
	 */
	public void init(ICommonContentExtensionSite aConfig) {
	}

	/**
	 * @generated
	 */
	public void restoreState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public void saveState(IMemento aMemento) {
	}

	/**
	 * @generated
	 */
	public String getDescription(Object anElement) {
		return null;
	}

	/**
	 * @generated
	 */
	private boolean isOwnView(View view) {
		return DiagramPackageEditPart.MODEL_ID.equals(OQBEmodelVisualIDRegistry
				.getModelID(view));
	}

}
