package OQBE.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;

import OQBE.Comparable;
import OQBE.Comparator;
import OQBE.DiagramPackage;
import OQBE.Example;
import OQBE.ForAll;
import OQBE.LinkExample;
import OQBE.NestedOutput;
import OQBE.OQBEPackage;
import OQBE.OclExpression;
import OQBE.OutputFlag;
import OQBE.Predicate;
import OQBE.SortFlag;
import OQBE.diagram.edit.parts.ComparatorEditPart;
import OQBE.diagram.edit.parts.DiagramPackageEditPart;
import OQBE.diagram.edit.parts.Example2EditPart;
import OQBE.diagram.edit.parts.Example3EditPart;
import OQBE.diagram.edit.parts.ExampleEditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment2EditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment3EditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartmentEditPart;
import OQBE.diagram.edit.parts.ForAll2EditPart;
import OQBE.diagram.edit.parts.ForAllEditPart;
import OQBE.diagram.edit.parts.LinkExampleEditPart;
import OQBE.diagram.edit.parts.NestedOutput2EditPart;
import OQBE.diagram.edit.parts.NestedOutputEditPart;
import OQBE.diagram.edit.parts.OclExpressionEditPart;
import OQBE.diagram.edit.parts.OutputFlag2EditPart;
import OQBE.diagram.edit.parts.OutputFlag3EditPart;
import OQBE.diagram.edit.parts.OutputFlagEditPart;
import OQBE.diagram.edit.parts.PredicateEditPart;
import OQBE.diagram.edit.parts.SortFlag2EditPart;
import OQBE.diagram.edit.parts.SortFlagEditPart;
import OQBE.diagram.providers.OQBEmodelElementTypes;

/**
 * @generated
 */
public class OQBEmodelDiagramUpdater {

	/**
	 * @generated
	 */
	public static List getSemanticChildren(View view) {
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case ExampleEditPart.VISUAL_ID:
			return getExample_1001SemanticChildren(view);
		case NestedOutputEditPart.VISUAL_ID:
			return getNestedOutput_1002SemanticChildren(view);
		case ForAllEditPart.VISUAL_ID:
			return getForAll_1003SemanticChildren(view);
		case PredicateEditPart.VISUAL_ID:
			return getPredicate_2001SemanticChildren(view);
		case OclExpressionEditPart.VISUAL_ID:
			return getOclExpression_2005SemanticChildren(view);
		case NestedOutput2EditPart.VISUAL_ID:
			return getNestedOutput_2008SemanticChildren(view);
		case Example2EditPart.VISUAL_ID:
			return getExample_2009SemanticChildren(view);
		case ForAll2EditPart.VISUAL_ID:
			return getForAll_2010SemanticChildren(view);
		case Example3EditPart.VISUAL_ID:
			return getExample_2011SemanticChildren(view);
		case ExamplePredicateCompartmentEditPart.VISUAL_ID:
			return getExamplePredicateCompartment_5001SemanticChildren(view);
		case ExamplePredicateCompartment2EditPart.VISUAL_ID:
			return getExamplePredicateCompartment_5002SemanticChildren(view);
		case ExamplePredicateCompartment3EditPart.VISUAL_ID:
			return getExamplePredicateCompartment_5003SemanticChildren(view);
		case DiagramPackageEditPart.VISUAL_ID:
			return getDiagramPackage_79SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_1001SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		{
			OutputFlag childElement = modelElement.getOutput();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OutputFlag2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_1002SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		NestedOutput modelElement = (NestedOutput) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getNestedOutputs().iterator(); it
				.hasNext();) {
			NestedOutput childElement = (NestedOutput) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == NestedOutput2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getNestedExamples().iterator(); it
				.hasNext();) {
			Example childElement = (Example) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Example2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getNestedForAlls().iterator(); it
				.hasNext();) {
			ForAll childElement = (ForAll) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ForAll2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getForAll_1003SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		ForAll modelElement = (ForAll) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getForAllExamples().iterator(); it
				.hasNext();) {
			Example childElement = (Example) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Example3EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPredicate_2001SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Predicate modelElement = (Predicate) view.getElement();
		List result = new LinkedList();
		{
			OutputFlag childElement = modelElement.getOutput();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OutputFlagEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		{
			SortFlag childElement = modelElement.getSort();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SortFlagEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getOclExpression_2005SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		OclExpression modelElement = (OclExpression) view.getElement();
		List result = new LinkedList();
		{
			OutputFlag childElement = modelElement.getOutput();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OutputFlag3EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		{
			SortFlag childElement = modelElement.getSort();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == SortFlag2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_2008SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		NestedOutput modelElement = (NestedOutput) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getNestedOutputs().iterator(); it
				.hasNext();) {
			NestedOutput childElement = (NestedOutput) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == NestedOutput2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getNestedExamples().iterator(); it
				.hasNext();) {
			Example childElement = (Example) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Example2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getNestedForAlls().iterator(); it
				.hasNext();) {
			ForAll childElement = (ForAll) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ForAll2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExample_2009SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		{
			OutputFlag childElement = modelElement.getOutput();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OutputFlag2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getForAll_2010SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		ForAll modelElement = (ForAll) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getForAllExamples().iterator(); it
				.hasNext();) {
			Example childElement = (Example) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == Example3EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExample_2011SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		{
			OutputFlag childElement = modelElement.getOutput();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OutputFlag2EditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExamplePredicateCompartment_5001SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getPredicates().iterator(); it
				.hasNext();) {
			Predicate childElement = (Predicate) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PredicateEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getExpressions().iterator(); it
				.hasNext();) {
			OclExpression childElement = (OclExpression) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OclExpressionEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExamplePredicateCompartment_5002SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getPredicates().iterator(); it
				.hasNext();) {
			Predicate childElement = (Predicate) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PredicateEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getExpressions().iterator(); it
				.hasNext();) {
			OclExpression childElement = (OclExpression) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OclExpressionEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExamplePredicateCompartment_5003SemanticChildren(
			View view) {
		if (false == view.eContainer() instanceof View) {
			return Collections.EMPTY_LIST;
		}
		View containerView = (View) view.eContainer();
		if (!containerView.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Example modelElement = (Example) containerView.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getPredicates().iterator(); it
				.hasNext();) {
			Predicate childElement = (Predicate) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PredicateEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getExpressions().iterator(); it
				.hasNext();) {
			OclExpression childElement = (OclExpression) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == OclExpressionEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getDiagramPackage_79SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		DiagramPackage modelElement = (DiagramPackage) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getExamples().iterator(); it.hasNext();) {
			Example childElement = (Example) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ExampleEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getOutputs().iterator(); it.hasNext();) {
			NestedOutput childElement = (NestedOutput) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == NestedOutputEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getForAlls().iterator(); it.hasNext();) {
			ForAll childElement = (ForAll) it.next();
			int visualID = OQBEmodelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == ForAllEditPart.VISUAL_ID) {
				result.add(new OQBEmodelNodeDescriptor(childElement, visualID));
				continue;
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case DiagramPackageEditPart.VISUAL_ID:
			return getDiagramPackage_79ContainedLinks(view);
		case ExampleEditPart.VISUAL_ID:
			return getExample_1001ContainedLinks(view);
		case NestedOutputEditPart.VISUAL_ID:
			return getNestedOutput_1002ContainedLinks(view);
		case ForAllEditPart.VISUAL_ID:
			return getForAll_1003ContainedLinks(view);
		case PredicateEditPart.VISUAL_ID:
			return getPredicate_2001ContainedLinks(view);
		case OutputFlagEditPart.VISUAL_ID:
			return getOutputFlag_2002ContainedLinks(view);
		case SortFlagEditPart.VISUAL_ID:
			return getSortFlag_2003ContainedLinks(view);
		case OutputFlag2EditPart.VISUAL_ID:
			return getOutputFlag_2004ContainedLinks(view);
		case OclExpressionEditPart.VISUAL_ID:
			return getOclExpression_2005ContainedLinks(view);
		case OutputFlag3EditPart.VISUAL_ID:
			return getOutputFlag_2006ContainedLinks(view);
		case SortFlag2EditPart.VISUAL_ID:
			return getSortFlag_2007ContainedLinks(view);
		case NestedOutput2EditPart.VISUAL_ID:
			return getNestedOutput_2008ContainedLinks(view);
		case Example2EditPart.VISUAL_ID:
			return getExample_2009ContainedLinks(view);
		case ForAll2EditPart.VISUAL_ID:
			return getForAll_2010ContainedLinks(view);
		case Example3EditPart.VISUAL_ID:
			return getExample_2011ContainedLinks(view);
		case LinkExampleEditPart.VISUAL_ID:
			return getLinkExample_3001ContainedLinks(view);
		case ComparatorEditPart.VISUAL_ID:
			return getComparator_3002ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case ExampleEditPart.VISUAL_ID:
			return getExample_1001IncomingLinks(view);
		case NestedOutputEditPart.VISUAL_ID:
			return getNestedOutput_1002IncomingLinks(view);
		case ForAllEditPart.VISUAL_ID:
			return getForAll_1003IncomingLinks(view);
		case PredicateEditPart.VISUAL_ID:
			return getPredicate_2001IncomingLinks(view);
		case OutputFlagEditPart.VISUAL_ID:
			return getOutputFlag_2002IncomingLinks(view);
		case SortFlagEditPart.VISUAL_ID:
			return getSortFlag_2003IncomingLinks(view);
		case OutputFlag2EditPart.VISUAL_ID:
			return getOutputFlag_2004IncomingLinks(view);
		case OclExpressionEditPart.VISUAL_ID:
			return getOclExpression_2005IncomingLinks(view);
		case OutputFlag3EditPart.VISUAL_ID:
			return getOutputFlag_2006IncomingLinks(view);
		case SortFlag2EditPart.VISUAL_ID:
			return getSortFlag_2007IncomingLinks(view);
		case NestedOutput2EditPart.VISUAL_ID:
			return getNestedOutput_2008IncomingLinks(view);
		case Example2EditPart.VISUAL_ID:
			return getExample_2009IncomingLinks(view);
		case ForAll2EditPart.VISUAL_ID:
			return getForAll_2010IncomingLinks(view);
		case Example3EditPart.VISUAL_ID:
			return getExample_2011IncomingLinks(view);
		case LinkExampleEditPart.VISUAL_ID:
			return getLinkExample_3001IncomingLinks(view);
		case ComparatorEditPart.VISUAL_ID:
			return getComparator_3002IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (OQBEmodelVisualIDRegistry.getVisualID(view)) {
		case ExampleEditPart.VISUAL_ID:
			return getExample_1001OutgoingLinks(view);
		case NestedOutputEditPart.VISUAL_ID:
			return getNestedOutput_1002OutgoingLinks(view);
		case ForAllEditPart.VISUAL_ID:
			return getForAll_1003OutgoingLinks(view);
		case PredicateEditPart.VISUAL_ID:
			return getPredicate_2001OutgoingLinks(view);
		case OutputFlagEditPart.VISUAL_ID:
			return getOutputFlag_2002OutgoingLinks(view);
		case SortFlagEditPart.VISUAL_ID:
			return getSortFlag_2003OutgoingLinks(view);
		case OutputFlag2EditPart.VISUAL_ID:
			return getOutputFlag_2004OutgoingLinks(view);
		case OclExpressionEditPart.VISUAL_ID:
			return getOclExpression_2005OutgoingLinks(view);
		case OutputFlag3EditPart.VISUAL_ID:
			return getOutputFlag_2006OutgoingLinks(view);
		case SortFlag2EditPart.VISUAL_ID:
			return getSortFlag_2007OutgoingLinks(view);
		case NestedOutput2EditPart.VISUAL_ID:
			return getNestedOutput_2008OutgoingLinks(view);
		case Example2EditPart.VISUAL_ID:
			return getExample_2009OutgoingLinks(view);
		case ForAll2EditPart.VISUAL_ID:
			return getForAll_2010OutgoingLinks(view);
		case Example3EditPart.VISUAL_ID:
			return getExample_2011OutgoingLinks(view);
		case LinkExampleEditPart.VISUAL_ID:
			return getLinkExample_3001OutgoingLinks(view);
		case ComparatorEditPart.VISUAL_ID:
			return getComparator_3002OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getDiagramPackage_79ContainedLinks(View view) {
		DiagramPackage modelElement = (DiagramPackage) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getContainedTypeModelFacetLinks_LinkExample_3001(modelElement));
		result
				.addAll(getContainedTypeModelFacetLinks_Comparator_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getExample_1001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_1002ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForAll_1003ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPredicate_2001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2002ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2003ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2004ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOclExpression_2005ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2006ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2007ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_2008ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2009ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForAll_2010ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2011ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getLinkExample_3001ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getComparator_3002ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_1001IncomingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_LinkExample_3001(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_Comparator_3002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_1002IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForAll_1003IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPredicate_2001IncomingLinks(View view) {
		Predicate modelElement = (Predicate) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_Comparator_3002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2002IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2003IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2004IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOclExpression_2005IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2006IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2007IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_2008IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2009IncomingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_LinkExample_3001(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_Comparator_3002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getForAll_2010IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2011IncomingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_LinkExample_3001(
				modelElement, crossReferences));
		result.addAll(getIncomingTypeModelFacetLinks_Comparator_3002(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getLinkExample_3001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getComparator_3002IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_1001OutgoingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_LinkExample_3001(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_Comparator_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_1002OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getForAll_1003OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPredicate_2001OutgoingLinks(View view) {
		Predicate modelElement = (Predicate) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_Comparator_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2002OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2003OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2004OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOclExpression_2005OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutputFlag_2006OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getSortFlag_2007OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getNestedOutput_2008OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2009OutgoingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_LinkExample_3001(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_Comparator_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getForAll_2010OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getExample_2011OutgoingLinks(View view) {
		Example modelElement = (Example) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingTypeModelFacetLinks_LinkExample_3001(modelElement));
		result
				.addAll(getOutgoingTypeModelFacetLinks_Comparator_3002(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getLinkExample_3001OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getComparator_3002OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_LinkExample_3001(
			DiagramPackage container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getObjects().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkExample) {
				continue;
			}
			LinkExample link = (LinkExample) linkObject;
			if (LinkExampleEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Example dst = link.getTarget();
			Example src = link.getSource();
			result.add(new OQBEmodelLinkDescriptor(src, dst, link,
					OQBEmodelElementTypes.LinkExample_3001,
					LinkExampleEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_Comparator_3002(
			DiagramPackage container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getObjects().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Comparator) {
				continue;
			}
			Comparator link = (Comparator) linkObject;
			if (ComparatorEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Comparable dst = link.getRightHandExp();
			Comparable src = link.getLeftHandExp();
			result.add(new OQBEmodelLinkDescriptor(src, dst, link,
					OQBEmodelElementTypes.Comparator_3002,
					ComparatorEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_LinkExample_3001(
			Example target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != OQBEPackage.eINSTANCE
					.getLinkExample_Target()
					|| false == setting.getEObject() instanceof LinkExample) {
				continue;
			}
			LinkExample link = (LinkExample) setting.getEObject();
			if (LinkExampleEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Example src = link.getSource();
			result.add(new OQBEmodelLinkDescriptor(src, target, link,
					OQBEmodelElementTypes.LinkExample_3001,
					LinkExampleEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_Comparator_3002(
			Comparable target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != OQBEPackage.eINSTANCE
					.getComparator_RightHandExp()
					|| false == setting.getEObject() instanceof Comparator) {
				continue;
			}
			Comparator link = (Comparator) setting.getEObject();
			if (ComparatorEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Comparable src = link.getLeftHandExp();
			result.add(new OQBEmodelLinkDescriptor(src, target, link,
					OQBEmodelElementTypes.Comparator_3002,
					ComparatorEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_LinkExample_3001(
			Example source) {
		DiagramPackage container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof DiagramPackage) {
				container = (DiagramPackage) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getObjects().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof LinkExample) {
				continue;
			}
			LinkExample link = (LinkExample) linkObject;
			if (LinkExampleEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Example dst = link.getTarget();
			Example src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new OQBEmodelLinkDescriptor(src, dst, link,
					OQBEmodelElementTypes.LinkExample_3001,
					LinkExampleEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_Comparator_3002(
			Comparable source) {
		DiagramPackage container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof DiagramPackage) {
				container = (DiagramPackage) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getObjects().iterator(); links
				.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Comparator) {
				continue;
			}
			Comparator link = (Comparator) linkObject;
			if (ComparatorEditPart.VISUAL_ID != OQBEmodelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Comparable dst = link.getRightHandExp();
			Comparable src = link.getLeftHandExp();
			if (src != source) {
				continue;
			}
			result.add(new OQBEmodelLinkDescriptor(src, dst, link,
					OQBEmodelElementTypes.Comparator_3002,
					ComparatorEditPart.VISUAL_ID));
		}
		return result;
	}

}
