package OQBE.diagram.part;

import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gmf.runtime.notation.Diagram;
import org.eclipse.gmf.runtime.notation.View;

import OQBE.DiagramPackage;
import OQBE.OQBEPackage;
import OQBE.diagram.edit.parts.ComparatorEditPart;
import OQBE.diagram.edit.parts.ComparatorOperatorEditPart;
import OQBE.diagram.edit.parts.DiagramPackageEditPart;
import OQBE.diagram.edit.parts.Example2EditPart;
import OQBE.diagram.edit.parts.Example3EditPart;
import OQBE.diagram.edit.parts.ExampleEditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassName2EditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassName3EditPart;
import OQBE.diagram.edit.parts.ExampleExampleNameClassNameEditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment2EditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartment3EditPart;
import OQBE.diagram.edit.parts.ExamplePredicateCompartmentEditPart;
import OQBE.diagram.edit.parts.ForAll2EditPart;
import OQBE.diagram.edit.parts.ForAllEditPart;
import OQBE.diagram.edit.parts.LinkExampleEditPart;
import OQBE.diagram.edit.parts.LinkExampleLinkNameEditPart;
import OQBE.diagram.edit.parts.NestedOutput2EditPart;
import OQBE.diagram.edit.parts.NestedOutputEditPart;
import OQBE.diagram.edit.parts.NestedOutputTupleFieldName2EditPart;
import OQBE.diagram.edit.parts.NestedOutputTupleFieldNameEditPart;
import OQBE.diagram.edit.parts.OclExpressionEditPart;
import OQBE.diagram.edit.parts.OclExpressionExpressionEditPart;
import OQBE.diagram.edit.parts.OutputFlag2EditPart;
import OQBE.diagram.edit.parts.OutputFlag3EditPart;
import OQBE.diagram.edit.parts.OutputFlagEditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldName2EditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldName3EditPart;
import OQBE.diagram.edit.parts.OutputFlagTupleFieldNameEditPart;
import OQBE.diagram.edit.parts.PredicateEditPart;
import OQBE.diagram.edit.parts.PredicatePredicateNameOperatorArEditPart;
import OQBE.diagram.edit.parts.SortFlag2EditPart;
import OQBE.diagram.edit.parts.SortFlagEditPart;
import OQBE.diagram.edit.parts.SortFlagOrderPriority2EditPart;
import OQBE.diagram.edit.parts.SortFlagOrderPriorityEditPart;
import OQBE.diagram.edit.parts.WrappingLabel2EditPart;
import OQBE.diagram.edit.parts.WrappingLabelEditPart;

/**
 * This registry is used to determine which type of visual object should be
 * created for the corresponding Diagram, Node, ChildNode or Link represented
 * by a domain model object.
 * 
 * @generated
 */
public class OQBEmodelVisualIDRegistry {

	/**
	 * @generated
	 */
	private static final String DEBUG_KEY = "VisualExpressionBuilderGMF.diagram/debug/visualID"; //$NON-NLS-1$

	/**
	 * @generated
	 */
	public static int getVisualID(View view) {
		if (view instanceof Diagram) {
			if (DiagramPackageEditPart.MODEL_ID.equals(view.getType())) {
				return DiagramPackageEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		return OQBE.diagram.part.OQBEmodelVisualIDRegistry.getVisualID(view
				.getType());
	}

	/**
	 * @generated
	 */
	public static String getModelID(View view) {
		View diagram = view.getDiagram();
		while (view != diagram) {
			EAnnotation annotation = view.getEAnnotation("Shortcut"); //$NON-NLS-1$
			if (annotation != null) {
				return (String) annotation.getDetails().get("modelID"); //$NON-NLS-1$
			}
			view = (View) view.eContainer();
		}
		return diagram != null ? diagram.getType() : null;
	}

	/**
	 * @generated
	 */
	public static int getVisualID(String type) {
		try {
			return Integer.parseInt(type);
		} catch (NumberFormatException e) {
			if (Boolean.TRUE.toString().equalsIgnoreCase(
					Platform.getDebugOption(DEBUG_KEY))) {
				OQBEmodelDiagramEditorPlugin.getInstance().logError(
						"Unable to parse view type as a visualID number: "
								+ type);
			}
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static String getType(int visualID) {
		return String.valueOf(visualID);
	}

	/**
	 * @generated
	 */
	public static int getDiagramVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (OQBEPackage.eINSTANCE.getDiagramPackage().isSuperTypeOf(
				domainElement.eClass())
				&& isDiagram((DiagramPackage) domainElement)) {
			return DiagramPackageEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static int getNodeVisualID(View containerView, EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		String containerModelID = OQBE.diagram.part.OQBEmodelVisualIDRegistry
				.getModelID(containerView);
		if (!DiagramPackageEditPart.MODEL_ID.equals(containerModelID)) {
			return -1;
		}
		int containerVisualID;
		if (DiagramPackageEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = OQBE.diagram.part.OQBEmodelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = DiagramPackageEditPart.VISUAL_ID;
			} else {
				return -1;
			}
		}
		switch (containerVisualID) {
		case ExampleEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getOutputFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return OutputFlag2EditPart.VISUAL_ID;
			}
			break;
		case NestedOutputEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getNestedOutput().isSuperTypeOf(
					domainElement.eClass())) {
				return NestedOutput2EditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getExample().isSuperTypeOf(
					domainElement.eClass())) {
				return Example2EditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getForAll().isSuperTypeOf(
					domainElement.eClass())) {
				return ForAll2EditPart.VISUAL_ID;
			}
			break;
		case ForAllEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getExample().isSuperTypeOf(
					domainElement.eClass())) {
				return Example3EditPart.VISUAL_ID;
			}
			break;
		case PredicateEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getOutputFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return OutputFlagEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getSortFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return SortFlagEditPart.VISUAL_ID;
			}
			break;
		case OclExpressionEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getOutputFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return OutputFlag3EditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getSortFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return SortFlag2EditPart.VISUAL_ID;
			}
			break;
		case NestedOutput2EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getNestedOutput().isSuperTypeOf(
					domainElement.eClass())) {
				return NestedOutput2EditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getExample().isSuperTypeOf(
					domainElement.eClass())) {
				return Example2EditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getForAll().isSuperTypeOf(
					domainElement.eClass())) {
				return ForAll2EditPart.VISUAL_ID;
			}
			break;
		case Example2EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getOutputFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return OutputFlag2EditPart.VISUAL_ID;
			}
			break;
		case ForAll2EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getExample().isSuperTypeOf(
					domainElement.eClass())) {
				return Example3EditPart.VISUAL_ID;
			}
			break;
		case Example3EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getOutputFlag().isSuperTypeOf(
					domainElement.eClass())) {
				return OutputFlag2EditPart.VISUAL_ID;
			}
			break;
		case ExamplePredicateCompartmentEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getPredicate().isSuperTypeOf(
					domainElement.eClass())) {
				return PredicateEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getOclExpression().isSuperTypeOf(
					domainElement.eClass())) {
				return OclExpressionEditPart.VISUAL_ID;
			}
			break;
		case ExamplePredicateCompartment2EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getPredicate().isSuperTypeOf(
					domainElement.eClass())) {
				return PredicateEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getOclExpression().isSuperTypeOf(
					domainElement.eClass())) {
				return OclExpressionEditPart.VISUAL_ID;
			}
			break;
		case ExamplePredicateCompartment3EditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getPredicate().isSuperTypeOf(
					domainElement.eClass())) {
				return PredicateEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getOclExpression().isSuperTypeOf(
					domainElement.eClass())) {
				return OclExpressionEditPart.VISUAL_ID;
			}
			break;
		case DiagramPackageEditPart.VISUAL_ID:
			if (OQBEPackage.eINSTANCE.getExample().isSuperTypeOf(
					domainElement.eClass())) {
				return ExampleEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getNestedOutput().isSuperTypeOf(
					domainElement.eClass())) {
				return NestedOutputEditPart.VISUAL_ID;
			}
			if (OQBEPackage.eINSTANCE.getForAll().isSuperTypeOf(
					domainElement.eClass())) {
				return ForAllEditPart.VISUAL_ID;
			}
			break;
		}
		return -1;
	}

	/**
	 * @generated
	 */
	public static boolean canCreateNode(View containerView, int nodeVisualID) {
		String containerModelID = OQBE.diagram.part.OQBEmodelVisualIDRegistry
				.getModelID(containerView);
		if (!DiagramPackageEditPart.MODEL_ID.equals(containerModelID)) {
			return false;
		}
		int containerVisualID;
		if (DiagramPackageEditPart.MODEL_ID.equals(containerModelID)) {
			containerVisualID = OQBE.diagram.part.OQBEmodelVisualIDRegistry
					.getVisualID(containerView);
		} else {
			if (containerView instanceof Diagram) {
				containerVisualID = DiagramPackageEditPart.VISUAL_ID;
			} else {
				return false;
			}
		}
		switch (containerVisualID) {
		case ExampleEditPart.VISUAL_ID:
			if (ExampleExampleNameClassNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ExamplePredicateCompartmentEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OutputFlag2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NestedOutputEditPart.VISUAL_ID:
			if (NestedOutputTupleFieldNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (NestedOutput2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Example2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ForAll2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ForAllEditPart.VISUAL_ID:
			if (WrappingLabelEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Example3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case PredicateEditPart.VISUAL_ID:
			if (PredicatePredicateNameOperatorArEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OutputFlagEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SortFlagEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OutputFlagEditPart.VISUAL_ID:
			if (OutputFlagTupleFieldNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SortFlagEditPart.VISUAL_ID:
			if (SortFlagOrderPriorityEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OutputFlag2EditPart.VISUAL_ID:
			if (OutputFlagTupleFieldName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OclExpressionEditPart.VISUAL_ID:
			if (OclExpressionExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OutputFlag3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (SortFlag2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case OutputFlag3EditPart.VISUAL_ID:
			if (OutputFlagTupleFieldName3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case SortFlag2EditPart.VISUAL_ID:
			if (SortFlagOrderPriority2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case NestedOutput2EditPart.VISUAL_ID:
			if (NestedOutputTupleFieldName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (NestedOutput2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Example2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ForAll2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Example2EditPart.VISUAL_ID:
			if (ExampleExampleNameClassName2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ExamplePredicateCompartment2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OutputFlag2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ForAll2EditPart.VISUAL_ID:
			if (WrappingLabel2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (Example3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case Example3EditPart.VISUAL_ID:
			if (ExampleExampleNameClassName3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ExamplePredicateCompartment3EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OutputFlag2EditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ExamplePredicateCompartmentEditPart.VISUAL_ID:
			if (PredicateEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OclExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ExamplePredicateCompartment2EditPart.VISUAL_ID:
			if (PredicateEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OclExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ExamplePredicateCompartment3EditPart.VISUAL_ID:
			if (PredicateEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (OclExpressionEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case DiagramPackageEditPart.VISUAL_ID:
			if (ExampleEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (NestedOutputEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			if (ForAllEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case LinkExampleEditPart.VISUAL_ID:
			if (LinkExampleLinkNameEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		case ComparatorEditPart.VISUAL_ID:
			if (ComparatorOperatorEditPart.VISUAL_ID == nodeVisualID) {
				return true;
			}
			break;
		}
		return false;
	}

	/**
	 * @generated
	 */
	public static int getLinkWithClassVisualID(EObject domainElement) {
		if (domainElement == null) {
			return -1;
		}
		if (OQBEPackage.eINSTANCE.getLinkExample().isSuperTypeOf(
				domainElement.eClass())) {
			return LinkExampleEditPart.VISUAL_ID;
		}
		if (OQBEPackage.eINSTANCE.getComparator().isSuperTypeOf(
				domainElement.eClass())) {
			return ComparatorEditPart.VISUAL_ID;
		}
		return -1;
	}

	/**
	 * User can change implementation of this method to handle some specific
	 * situations not covered by default logic.
	 * 
	 * @generated
	 */
	private static boolean isDiagram(DiagramPackage element) {
		return true;
	}

}
