/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package OQBE.provider;


import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterDirectionKind;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.TypedElement;
import org.eclipse.uml2.uml.UMLPackage;

import OQBE.Example;
import OQBE.OQBEFactory;
import OQBE.OQBEPackage;

/**
 * This is the item provider adapter for a {@link OQBE.Example} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExampleItemProvider
	extends ComparableItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExampleItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addExampleNamePropertyDescriptor(object);
			addClassNamePropertyDescriptor(object);
			addDescribesPropertyDescriptor(object);
			addLinkSourcesPropertyDescriptor(object);
			addLinkTargetsPropertyDescriptor(object);
			addContextNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Example Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addExampleNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_exampleName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_exampleName_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__EXAMPLE_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Class Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addClassNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_className_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_className_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__CLASS_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Describes feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addDescribesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_describes_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_describes_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__DESCRIBES,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					
					if (object instanceof OQBE.Example) {
						if (((OQBE.Example) object).getLinkTargets() != null) {
							for (Iterator i = ((OQBE.Example) object).getLinkTargets().iterator(); i.hasNext();) {
								Object o = i.next();
								if (o instanceof OQBE.LinkExample) {
									if(((OQBE.LinkExample) o).getDescribedBy() != null) {
										result.add(((OQBE.LinkExample) o).getDescribedBy().getType());
										result.add(null);
									
										return result;
									}
								}
							}
						}
					}
					
					result.addAll(super.getChoiceOfValues(object));
					for (Iterator i = result.iterator(); i.hasNext();) {
						Object o = i.next();
						if (o instanceof org.eclipse.uml2.uml.Class) {
							if (((org.eclipse.uml2.uml.Class) o).eClass() != UMLPackage.Literals.CLASS ||
									((org.eclipse.uml2.uml.Class) o).getAppliedStereotypes().size() > 0) {
								i.remove();
							}
						}
					}
					
					return result;
				}
			});
	}

	/**
	 * This adds a property descriptor for the Context Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addContextNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_contextName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_contextName_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__CONTEXT_NAME,
				 true,
				 false,
				 false,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					
					result.add(null);
					
					for (Object o : ((OQBE.Example) object).eResource().getContents()) {
						if (o instanceof OQBE.DiagramPackage) {
							if (((OQBE.DiagramPackage) o).getContext() != null) {
								for (Object t : ((OQBE.DiagramPackage) o).getContext().getNames()) {
									if (t instanceof TypedElement) {
										if (((TypedElement) t).getType().eClass() == UMLPackage.Literals.CLASS) {
											result.add(t);
											// add attributes from the class of self
											if (((TypedElement) t).getName().equals("self")) {
												for (Property p : ((org.eclipse.uml2.uml.Class) ((TypedElement) t).getType()).getOwnedAttributes()) {
													if (p.getType() != null) {
														if (p.getType().eClass() == UMLPackage.Literals.CLASS) {
															result.add(p);
														}
													}
												}
											}
										}
									}
								}
								//FIXME change operation to a reference to the class of self
								Operation operation = ((OQBE.DiagramPackage) o).getContext().getOperation();
								if (operation != null) {
									/* Properties are added from self class instead of from operation
									for (Property p : operation.getClass_().getOwnedAttributes()) {
										if (p.getType().eClass() == UMLPackage.Literals.CLASS) {
											result.add(p);
										}
									}
									*/
									// Filter return parameters.
									for (Parameter p : operation.getOwnedParameters()) {
										if (p.getDirection() != ParameterDirectionKind.RETURN_LITERAL) {
											if (p.getType().eClass() == UMLPackage.Literals.CLASS) {
												result.add(p);
											}
										}
									}
								}
							}
						}
					}
					
					return result;
				}
			});
	}

	/**
	 * This adds a property descriptor for the Link Sources feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLinkSourcesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_linkSources_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_linkSources_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__LINK_SOURCES,
				 false,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Link Targets feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLinkTargetsPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Example_linkTargets_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Example_linkTargets_feature", "_UI_Example_type"),
				 OQBEPackage.Literals.EXAMPLE__LINK_TARGETS,
				 false,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(OQBEPackage.Literals.EXAMPLE__PREDICATES);
			childrenFeatures.add(OQBEPackage.Literals.EXAMPLE__OUTPUT);
			childrenFeatures.add(OQBEPackage.Literals.EXAMPLE__EXPRESSIONS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Example.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Example"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((Example)object).getExampleName();
		return label == null || label.length() == 0 ?
			getString("_UI_Example_type") :
			getString("_UI_Example_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Example.class)) {
			case OQBEPackage.EXAMPLE__EXAMPLE_NAME:
			case OQBEPackage.EXAMPLE__CLASS_NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case OQBEPackage.EXAMPLE__PREDICATES:
			case OQBEPackage.EXAMPLE__OUTPUT:
			case OQBEPackage.EXAMPLE__EXPRESSIONS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(OQBEPackage.Literals.EXAMPLE__PREDICATES,
				 OQBEFactory.eINSTANCE.createPredicate()));

		newChildDescriptors.add
			(createChildParameter
				(OQBEPackage.Literals.EXAMPLE__OUTPUT,
				 OQBEFactory.eINSTANCE.createOutputFlag()));

		newChildDescriptors.add
			(createChildParameter
				(OQBEPackage.Literals.EXAMPLE__EXPRESSIONS,
				 OQBEFactory.eINSTANCE.createOclExpression()));
	}

}
