/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package OQBE.provider;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.VisibilityKind;

import OQBE.LinkExample;
import OQBE.OQBEPackage;

/**
 * This is the item provider adapter for a {@link OQBE.LinkExample} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class LinkExampleItemProvider
	extends DiagramObjectItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkExampleItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addLinkNamePropertyDescriptor(object);
			addSourcePropertyDescriptor(object);
			addTargetPropertyDescriptor(object);
			addDescribedByPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Link Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addLinkNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_LinkExample_linkName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_LinkExample_linkName_feature", "_UI_LinkExample_type"),
				 OQBEPackage.Literals.LINK_EXAMPLE__LINK_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Source feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addSourcePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_LinkExample_source_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_LinkExample_source_feature", "_UI_LinkExample_type"),
				 OQBEPackage.Literals.LINK_EXAMPLE__SOURCE,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Target feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addTargetPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_LinkExample_target_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_LinkExample_target_feature", "_UI_LinkExample_type"),
				 OQBEPackage.Literals.LINK_EXAMPLE__TARGET,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Described By feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addDescribedByPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_LinkExample_describedBy_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_LinkExample_describedBy_feature", "_UI_LinkExample_type"),
				 OQBEPackage.Literals.LINK_EXAMPLE__DESCRIBED_BY,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					if (object instanceof OQBE.LinkExample) {
						if (((OQBE.LinkExample) object).getSource().getDescribes() != null) {
							org.eclipse.uml2.uml.Class s = ((OQBE.LinkExample) object).getSource().getDescribes();
							org.eclipse.uml2.uml.Class t = ((OQBE.LinkExample) object).getTarget().getDescribes();
							
							EList<Association> associations = new BasicEList<Association>();
							addClassAssociations(s, associations);
							for (Object a : associations) {
								for (Property p : ((org.eclipse.uml2.uml.Association) a).getMemberEnds()) {
									if ((p.getType() != s && !s.allParents().contains(p.getType())) || p.getType() == p.getOtherEnd().getType()) {
										if (p.getOtherEnd().isNavigable() == false ||	// Include both ends navigable.
												(p.isNavigable() == true && p.getOtherEnd().isNavigable() == true)) {
											if ((p.getOtherEnd().getType() != s && p.getVisibility() != VisibilityKind.PRIVATE_LITERAL) ||
													p.getOtherEnd().getType() == s) {
												if (t == null || p.getType() == t) {
													result.add(p);
												}
											}
										}
									}
								}
							}
							// Include compositions.
							for (Property p : s.getAllAttributes()) {
								if (p.getType() instanceof org.eclipse.uml2.uml.Class) {
									if (t == null || p.getType() == t) {
										result.add(p);
									}
								}
							}
						}
					}
					result.add(null);
					
					return result;
				}
			});
	}
	
	/**
	 * This adds all Associations from all generalizations of a class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	private void addClassAssociations(Classifier c, EList<Association> associations) {
		associations.addAll(c.getAssociations());
		for (Classifier superClass : c.allParents()) {
			associations.addAll(superClass.getAssociations());
		}
	}

	/**
	 * This returns LinkExample.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/LinkExample"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((LinkExample)object).getLinkName();
		return label == null || label.length() == 0 ?
			getString("_UI_LinkExample_type") :
			getString("_UI_LinkExample_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(LinkExample.class)) {
			case OQBEPackage.LINK_EXAMPLE__LINK_NAME:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);
	}

}
