/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package OQBE.provider;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;
import org.eclipse.ocl.types.OCLStandardLibrary;
import org.eclipse.ocl.uml.UMLEnvironment;
import org.eclipse.ocl.uml.UMLEnvironmentFactory;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterDirectionKind;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.TypedElement;

import OQBE.OQBEFactory;
import OQBE.OQBEPackage;
import OQBE.Predicate;

/**
 * This is the item provider adapter for a {@link OQBE.Predicate} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class PredicateItemProvider
	extends ComparableItemProvider
	implements	
		IEditingDomainItemProvider,	
		IStructuredItemContentProvider,	
		ITreeItemContentProvider,	
		IItemLabelProvider,	
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredicateItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addPredicateNamePropertyDescriptor(object);
			addOperatorPropertyDescriptor(object);
			addArgumentPropertyDescriptor(object);
			addSubjectPropertyDescriptor(object);
			addOperationPropertyDescriptor(object);
			addContextNamePropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Predicate Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addPredicateNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_predicateName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_predicateName_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__PREDICATE_NAME,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Operator feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOperatorPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_operator_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_operator_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__OPERATOR,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Argument feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addArgumentPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_argument_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_argument_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__ARGUMENT,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This adds a property descriptor for the Subject feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addSubjectPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_subject_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_subject_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__SUBJECT,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					if (((OQBE.Example) ((OQBE.Predicate) object).eContainer()).getDescribes() != null) {
						for (Object p : ((OQBE.Example) ((OQBE.Predicate) object).eContainer()).getDescribes().getAllAttributes()) {
							if (p instanceof org.eclipse.uml2.uml.Property) {
								result.add(p);
							}
						}
					}
					result.add(null);
					
					return result;
				}
			});
	}

	/**
	 * This adds a property descriptor for the Operation feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addOperationPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_operation_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_operation_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__OPERATION,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					Property property = ((OQBE.Predicate) object).getSubject();
					
					if (property != null) {
						if (property.getLower() == 1 && property.getUpper() == 1) {
							for (Object o : ((Classifier)property.getType()).getOperations()) {
								if (((Operation) o).getReturnResult().getType().getName().equals("Boolean"))
									result.add(o);
							}
						} else {
							// Requires org.eclipse.ocl.uml in plugin.xml Dependencies.
							UMLEnvironmentFactory eFactory = new UMLEnvironmentFactory();
							UMLEnvironment environment = eFactory.createEnvironment();
							OCLStandardLibrary<Classifier> oclStdLib = environment.getOCLStandardLibrary();
							for (Object o : oclStdLib.getCollection().getOperations()) {
								if (((Operation) o).getReturnResult().getType().getName().equals("Boolean")) {
									result.add(o);
								}
							}
						}
					}
					
					result.add(null);
					
					return result;
				}
			});
	}

	/**
	 * This adds a property descriptor for the Context Name feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected void addContextNamePropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(new ItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_Predicate_contextName_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_Predicate_contextName_feature", "_UI_Predicate_type"),
				 OQBEPackage.Literals.PREDICATE__CONTEXT_NAME,
				 true,
				 false,
				 false,
				 null,
				 null,
				 null) {
				public Collection<?> getChoiceOfValues(Object object) {
					Collection<Object> result = new ArrayList<Object>();
					
					result.add(null);
					
					for (Object o : ((OQBE.Predicate) object).eResource().getContents()) {
						if (o instanceof OQBE.DiagramPackage) {
							if (((OQBE.DiagramPackage) o).getContext() != null) {
								for (Object t : ((OQBE.DiagramPackage) o).getContext().getNames()) {
									if (t instanceof TypedElement) {
										result.add(t);
										// add attributes from the class of self
										if (((TypedElement) t).getName().equals("self")) {
											result.addAll(((org.eclipse.uml2.uml.Class) ((TypedElement) t).getType()).getOwnedAttributes());
										}
									}
								}
								//FIXME change operation to a reference to the class of self
								Operation operation = ((OQBE.DiagramPackage) o).getContext().getOperation();
								// Filter return parameters.
								if (operation != null) {
									for (Parameter p : operation.getOwnedParameters()) {
										if (p.getDirection() != ParameterDirectionKind.RETURN_LITERAL) {
											result.add(p);
										}
									}
									/* Properties are added from self class instead of from operation
									result.addAll(operation.getClass_().getOwnedAttributes());
									*/
								}
							}
						}
					}
					
					addExampleProperties((OQBE.Example) ((OQBE.Predicate) object).eContainer(), result);
					
					return result;
				}
				
				@Override
				public IItemLabelProvider getLabelProvider(Object object) {
					return new ItemDelegator(adapterFactory, resourceLocator) {
						@Override
						public String getText(Object object) {
							if (object instanceof Property) {
								return "[" + ((Property) object).getClass_().getLabel() + "] " + super.getText(object);
							} else {
								return super.getText(object);
							}
						}
					};
				}
			});
	}
	
	/**
	 * This adds the Properties from all preceding Examples to the resulting context names.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	private void addExampleProperties(OQBE.Example example, Collection<Object> result) {
		if (example.getDescribes() != null) {
			for (Property p : example.getDescribes().getAllAttributes()) {
				if (!result.contains(p)) {
					result.add(p);
				}
			}
		}
		
		for (Object l : example.getLinkTargets()) {
			if (l instanceof OQBE.LinkExample) {
				// Use ((OQBE.LinkExample) l).getDescribedBy != null to stop on links without a association reference.
				addExampleProperties(((OQBE.LinkExample) l).getSource(), result);
			}
		}
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(OQBEPackage.Literals.PREDICATE__OUTPUT);
			childrenFeatures.add(OQBEPackage.Literals.PREDICATE__SORT);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns Predicate.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/Predicate"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getText(Object object) {
		String label = ((Predicate)object).getPredicateName();
		return label == null || label.length() == 0 ?
			getString("_UI_Predicate_type") :
			getString("_UI_Predicate_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(Predicate.class)) {
			case OQBEPackage.PREDICATE__PREDICATE_NAME:
			case OQBEPackage.PREDICATE__OPERATOR:
			case OQBEPackage.PREDICATE__ARGUMENT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case OQBEPackage.PREDICATE__OUTPUT:
			case OQBEPackage.PREDICATE__SORT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void collectNewChildDescriptors(Collection newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(OQBEPackage.Literals.PREDICATE__OUTPUT,
				 OQBEFactory.eINSTANCE.createOutputFlag()));

		newChildDescriptors.add
			(createChildParameter
				(OQBEPackage.Literals.PREDICATE__SORT,
				 OQBEFactory.eINSTANCE.createSortFlag()));
	}

}
