package oqbe.exporters;

import org.eclipse.emf.ecore.EObject;

import vide.ast.abstracts.AbstractNode;

public abstract class OQBEItem implements Comparable<OQBEItem> {

	public EObject diagramItem;
	public AbstractNode astNode;	
	public String fieldName;
		
	public OQBEItem(EObject diagramItem, AbstractNode astNode, String fieldName) {
		this.diagramItem = diagramItem;
		this.astNode = astNode;
		this.fieldName = fieldName;
	}
			
	public String asString() {
		String result = "diagramItem: ";
		if (diagramItem != null)
			result += diagramItem.toString();
		else
			result += "null";
		result = result.replace("OQBE.impl.", "");
		
		result += ", astNode: ";
		if (astNode != null)
			result += astNode.asExp();
		else
			result += "null";
		
		result += ", fieldName: ";
		result += fieldName;
		
		return result;
	}
}
