package oqbe.exporters;

import java.util.Stack;

import vide.ast.abstracts.AbstractNode;

public class SimpleLogger {

	
	protected boolean logging = false;
	//protected boolean logging = true;
	
	protected static SimpleLogger instance = new SimpleLogger();
	protected String indent = "";
	protected Stack<String> methodNames = new Stack<String>();
	protected final static String indChar = "  ";
	
	public static SimpleLogger getInstance() {
		return instance;
	}
	
	public SimpleLogger() {
	}
	
	//
	
	protected String removeWhiteChars(String s) {
		return s.replace("\n", "\n" + indent + "    ");
	}
	
	//
	
	public void startOfMethod(String methodName) {
		if (logging) {
			methodNames.push(methodName);
			incIndent();
			System.out.println(indent + methodName + " - start");
		}
	}
	
	public void endOfMethod(AbstractNode expression) {
		if (logging) {		
			String expValue = "null";
			if (expression != null)
				expValue = removeWhiteChars("\n" + expression.asExp());
			System.out.println(indent + indChar + "result:" + expValue);
			System.out.println(indent + methodNames.pop() + " - end");
			decIndent();			
		}
	}
	
	public void message(String msg, AbstractNode expression) {
		if (logging) {		
			String expValue = "null";
			if (expression != null)
				expValue = removeWhiteChars("\n" + expression.asExp());
			System.out.println(indent + indChar + msg + ": " + expValue);			
		}
	}
	
	public void printLogLine(String line) {
		if (logging) 
			System.out.println(indent + indChar + removeWhiteChars(line));
	}

	//
	
	public void incIndent() {
		indent += indChar;
	}

	public void decIndent() {		
		if (indent.length() - indChar.length() >= 0)
			indent = indent.substring(0, indent.length() - indChar.length());
		else
			System.out.println("Indentation error!");
	}
	
}
