/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package OQBE.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import OQBE.Comparator;
import OQBE.Context;
import OQBE.DiagramPackage;
import OQBE.Example;
import OQBE.ForAll;
import OQBE.LinkExample;
import OQBE.NestedOutput;
import OQBE.OQBEFactory;
import OQBE.OQBEPackage;
import OQBE.OclExpression;
import OQBE.OutputFlag;
import OQBE.Predicate;
import OQBE.SortFlag;
import OQBE.SortOrder;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OQBEFactoryImpl extends EFactoryImpl implements OQBEFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static OQBEFactory init() {
		try {
			OQBEFactory theOQBEFactory = (OQBEFactory)EPackage.Registry.INSTANCE.getEFactory("editor"); 
			if (theOQBEFactory != null) {
				return theOQBEFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new OQBEFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OQBEFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case OQBEPackage.DIAGRAM_PACKAGE: return createDiagramPackage();
			case OQBEPackage.EXAMPLE: return createExample();
			case OQBEPackage.LINK_EXAMPLE: return createLinkExample();
			case OQBEPackage.PREDICATE: return createPredicate();
			case OQBEPackage.COMPARATOR: return createComparator();
			case OQBEPackage.OUTPUT_FLAG: return createOutputFlag();
			case OQBEPackage.SORT_FLAG: return createSortFlag();
			case OQBEPackage.CONTEXT: return createContext();
			case OQBEPackage.NESTED_OUTPUT: return createNestedOutput();
			case OQBEPackage.OCL_EXPRESSION: return createOclExpression();
			case OQBEPackage.FOR_ALL: return createForAll();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case OQBEPackage.SORT_ORDER:
				return createSortOrderFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case OQBEPackage.SORT_ORDER:
				return convertSortOrderToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DiagramPackage createDiagramPackage() {
		DiagramPackageImpl diagramPackage = new DiagramPackageImpl();
		return diagramPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Example createExample() {
		ExampleImpl example = new ExampleImpl();
		return example;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkExample createLinkExample() {
		LinkExampleImpl linkExample = new LinkExampleImpl();
		return linkExample;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Predicate createPredicate() {
		PredicateImpl predicate = new PredicateImpl();
		return predicate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Comparator createComparator() {
		ComparatorImpl comparator = new ComparatorImpl();
		return comparator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OutputFlag createOutputFlag() {
		OutputFlagImpl outputFlag = new OutputFlagImpl();
		return outputFlag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SortFlag createSortFlag() {
		SortFlagImpl sortFlag = new SortFlagImpl();
		return sortFlag;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Context createContext() {
		ContextImpl context = new ContextImpl();
		return context;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NestedOutput createNestedOutput() {
		NestedOutputImpl nestedOutput = new NestedOutputImpl();
		return nestedOutput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OclExpression createOclExpression() {
		OclExpressionImpl oclExpression = new OclExpressionImpl();
		return oclExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ForAll createForAll() {
		ForAllImpl forAll = new ForAllImpl();
		return forAll;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SortOrder createSortOrderFromString(EDataType eDataType, String initialValue) {
		SortOrder result = SortOrder.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertSortOrderToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OQBEPackage getOQBEPackage() {
		return (OQBEPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	public static OQBEPackage getPackage() {
		return OQBEPackage.eINSTANCE;
	}

} //OQBEFactoryImpl
