/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package OQBE.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import OQBE.Comparator;
import OQBE.Context;
import OQBE.DiagramObject;
import OQBE.DiagramPackage;
import OQBE.Example;
import OQBE.ForAll;
import OQBE.LinkExample;
import OQBE.NestedOutput;
import OQBE.OQBEPackage;
import OQBE.OclExpression;
import OQBE.OutputFlag;
import OQBE.Predicate;
import OQBE.SortFlag;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see OQBE.OQBEPackage
 * @generated
 */
public class OQBEAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static OQBEPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OQBEAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = OQBEPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected OQBESwitch modelSwitch =
		new OQBESwitch() {
			public Object caseDiagramPackage(DiagramPackage object) {
				return createDiagramPackageAdapter();
			}
			public Object caseExample(Example object) {
				return createExampleAdapter();
			}
			public Object caseDiagramObject(DiagramObject object) {
				return createDiagramObjectAdapter();
			}
			public Object caseLinkExample(LinkExample object) {
				return createLinkExampleAdapter();
			}
			public Object casePredicate(Predicate object) {
				return createPredicateAdapter();
			}
			public Object caseComparator(Comparator object) {
				return createComparatorAdapter();
			}
			public Object caseOutputFlag(OutputFlag object) {
				return createOutputFlagAdapter();
			}
			public Object caseSortFlag(SortFlag object) {
				return createSortFlagAdapter();
			}
			public Object caseContext(Context object) {
				return createContextAdapter();
			}
			public Object caseNestedOutput(NestedOutput object) {
				return createNestedOutputAdapter();
			}
			public Object caseOclExpression(OclExpression object) {
				return createOclExpressionAdapter();
			}
			public Object caseForAll(ForAll object) {
				return createForAllAdapter();
			}
			public Object caseComparable(OQBE.Comparable object) {
				return createComparableAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link OQBE.DiagramPackage <em>Diagram Package</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.DiagramPackage
	 * @generated
	 */
	public Adapter createDiagramPackageAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.Example <em>Example</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.Example
	 * @generated
	 */
	public Adapter createExampleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.DiagramObject <em>Diagram Object</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.DiagramObject
	 * @generated
	 */
	public Adapter createDiagramObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.LinkExample <em>Link Example</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.LinkExample
	 * @generated
	 */
	public Adapter createLinkExampleAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.Predicate <em>Predicate</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.Predicate
	 * @generated
	 */
	public Adapter createPredicateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.Comparator <em>Comparator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.Comparator
	 * @generated
	 */
	public Adapter createComparatorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.OutputFlag <em>Output Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.OutputFlag
	 * @generated
	 */
	public Adapter createOutputFlagAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.SortFlag <em>Sort Flag</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.SortFlag
	 * @generated
	 */
	public Adapter createSortFlagAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.Context <em>Context</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.Context
	 * @generated
	 */
	public Adapter createContextAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.NestedOutput <em>Nested Output</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.NestedOutput
	 * @generated
	 */
	public Adapter createNestedOutputAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.OclExpression <em>Ocl Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.OclExpression
	 * @generated
	 */
	public Adapter createOclExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.ForAll <em>For All</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.ForAll
	 * @generated
	 */
	public Adapter createForAllAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link OQBE.Comparable <em>Comparable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see OQBE.Comparable
	 * @generated
	 */
	public Adapter createComparableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //OQBEAdapterFactory
